///////////////////////////////////////////////////////////////////////////////
//                                                                           //
// (c) Copyright OCP-IP 2008
// OCP-IP Confidential and Proprietary
//
//
//============================================================================
//      Project : OCP SLD WG
//       Author : Robert Guenzel (from TU of Braunschweig) for Greensocs Ltd.
//
//          $Id:
//
//  Description :  
//                 This file contains a byte enable conversion helper function.
//                 It will be moved into a namespace later on.
//
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

#ifndef OCPIP_VERSION
  #error ocp_monitor_helpers.h may not be included directly. Use #inculde "ocpip.h" or #include "ocpip_X_X_X.h" (where desired ocp version is X.X.X)
#endif

namespace OCPIP_VERSION{

//struct ocp_monitor_helpers{
//  static inline void setBE(unsigned int& ByteEN, tlm::tlm_generic_payload* txn, unsigned int data_width_in_bytes, unsigned int chunk);
//};

template <unsigned int BUSWIDTH>
class ocp_connection_monitor: public OCPIP_VERSION::infr::monitor<BUSWIDTH, tlm::tlm_base_protocol_types>
{
public:
  template <unsigned int M, unsigned int N, typename M_SOCKET_BASE, typename N_SOCKET_BASE>
  ocp_connection_monitor(ocp_master_socket<BUSWIDTH,M,M_SOCKET_BASE>& msock, ocp_slave_socket<BUSWIDTH,N,N_SOCKET_BASE>& ssock):
    OCPIP_VERSION::infr::monitor<BUSWIDTH, tlm::tlm_base_protocol_types>(
        sc_core::sc_gen_unique_name("ocp_socket_connection_monitor")
      , msock.name()
      , ssock.name())
  {
    msock(this->t_socket);
    this->i_socket(ssock);
  }
};


}
#include __MACRO_STRINGYFY__(../mon/src/OCPIP_VERSION/ocp_monitor_helpers.hpp)
