// 
//  Copyright 2005 OCP-IP
//
// ============================================================================
//      Project : OCP SLD WG
//       Author : Anssi Haverinen, Nokia Inc.
//           $Id: master.h,v 1.1 2005/01/07 03:42:33 Anssi Exp $
//
//  Description : OCP - TL1 AMBD profile example
//
// ============================================================================

#ifndef _OCP_TL1_MASTER_W_H
#define _OCP_TL1_MASTER_W_H

// Turn on debug messages
#define DEBUG_G1

#include <iostream>
#include "stdlib.h"

// User defined types
#include "channel_types.h"

// OCP-IP Channel header files
#include "ocp_globals.h"
#include "ocp_tl1_master_port.h"
#include "ocp_tl_param_cl.h"

#include "fifo.h"

class Master : public sc_module
{
public:  
  
  typedef OCPCHANNELBit32 Td;
  typedef OCPCHANNELBit32 Ta;

  // channel port
  OCP_TL1_MasterPort<OCP_TL1_DataCl<OCPCHANNELBit32, OCPCHANNELBit32> > ipP;

  // TL1 clock
  sc_in_clk  clk;

  SC_HAS_PROCESS(Master);

  // constructor
  Master(sc_module_name name_);

  // destructor
  ~Master();

  // threads
  void proc();

  int cnt, burstcnt;
  int wraplen;
  bool read;
  unsigned int protbits;
  Ta addr;
  bool srmd_cont;

  fifo<Td, 100> req_fifo;

  // Request group
  OCPRequestGrp<Td,Ta> req;

  // Request data group
  OCPDataHSGrp<Td> req_data;

  // Response group
  OCPResponseGrp<Td> resp;

};


#endif // _OCP_TL1_MASTER_W_H
