// 
//  Copyright 2003 OCP-IP
//  OCP-IP Confidential and Proprietary
// ============================================================================
//      Project : OCP SLD WG
//       Author : Yann Bajot , Prosilog
//         Date : 06/23/2003
//
//  Description : Transaction Level Slave port declaration.
//                These methods are implemented in the Channel
//                (see tl_channel.h)
//
// ============================================================================


#ifndef TL_SLAVE_PORTS_H
#define TL_SLAVE_PORTS_H

#include "systemc/communication/sc_event_finder.h"
#include "tl_slave_if.h"


template <class TdataCl> class tl_slave_port
: public sc_port<TLslaveIF<TdataCl>, 1>
{
    public:

    tl_slave_port(const char* name)
        : sc_port<TLslaveIF<TdataCl>, 1>(name)
        {}

  // Access to the main events of the Communication class using event finders
	sc_event_finder& RequestStartEvent() const { return *new sc_event_finder_t<TLslaveIF<TdataCl> >( *this, &TLslaveIF<TdataCl>::RequestStartEvent ); }
	sc_event_finder& RequestEndEvent() const { return *new sc_event_finder_t<TLslaveIF<TdataCl> >( *this, &TLslaveIF<TdataCl>::RequestEndEvent ); }
	sc_event_finder& DataRequestStartEvent() const { return *new sc_event_finder_t<TLslaveIF<TdataCl> >( *this, &TLslaveIF<TdataCl>::DataRequestStartEvent ); }
	sc_event_finder& DataRequestEndEvent() const { return *new sc_event_finder_t<TLslaveIF<TdataCl> >( *this, &TLslaveIF<TdataCl>::DataRequestEndEvent ); }
	sc_event_finder& ResponseStartEvent() const { return *new sc_event_finder_t<TLslaveIF<TdataCl> >( *this, &TLslaveIF<TdataCl>::ResponseStartEvent ); }
	sc_event_finder& ResponseEndEvent() const { return *new sc_event_finder_t<TLslaveIF<TdataCl> >( *this, &TLslaveIF<TdataCl>::ResponseEndEvent ); }

};


#endif

